
' An Actual Pirate Game
' Pirate Kart 2012
' Kristopher Windsor

#include once "fbgfx.bi"

const sx = 800, sy = 600

type xyt
  as double x, y
end type

dim shared as integer offset, is_fired = 0, is_sinking = 0
dim shared as xyt good, bad, bullet, bullet_v
dim shared as fb.image ptr background, goodship, badship

screenres sx, sy, 32

background = imagecreate(sx, sy)
goodship = imagecreate(200, 244)
badship = imagecreate(233, 250)

bload("background.bmp", background)
bload("goodship.bmp", goodship)
bload("badship.bmp", badship)

good = type(60, 110)
bad = type(480, 130)
bullet = type(260 + cos(timer() * 1.2) * 5, 280 + cos(timer() * 1.3) * 10)
bullet_v = type(15, -5)

do
  offset -= 1
  if offset < 0 then offset += sx
  
  if is_fired then
    bullet_v.y += 1
    bullet.x += bullet_v.x
    bullet.y += bullet_v.y
    if bullet.x > bad.x then is_sinking = -1
  end if
  if is_sinking then bad.y += 3
  
  if multikey(fb.sc_space) then is_fired = -1
  
  screenlock()
  put (offset, 0), background, pset
  put (offset - sx, 0), background, pset
  with good
    put (.x + cos(timer() * 1.2) * 5, .y + cos(timer() * 1.3) * 10), goodship, trans
  end with
  with bad
    put (.x + cos(timer() * 1.21) * 5, .y + cos(timer() * 1.31) * 10), badship, trans
  end with
  if is_fired and is_sinking = 0 then
    circle (bullet.x, bullet.y), 8, &HFF000000,,, 1, F
  end if
  screenunlock()
  
  sleep(18, 1)
loop while inkey() <> chr(27) and bad.y < sy
